// Generated by CoffeeScript 1.6.3
(function() {
  "use strict";
  var CypherQuery, extend, isArray, isString,
    __slice = [].slice;

  isString = function(val) {
    return typeof val === 'string';
  };

  isArray = function(val) {
    return typeof val === 'array';
  };

  extend = function(target, source) {
    var k, v;
    for (k in source) {
      v = source[k];
      target[k] = v;
    }
    return target;
  };

  CypherQuery = (function() {
    var PARTS, k, part_builder, _i, _len;

    PARTS = ['start', 'match', 'where', 'with', 'set', 'delete', 'forach', 'return', 'union', 'union all', 'order by', 'limit', 'skip'];

    function CypherQuery(opt) {
      var key, val;
      if (typeof this === "undefined" || this === null) {
        return new CypherQuery(opt);
      }
      this._params = {};
      this._query = {};
      if (opt != null) {
        for (key in opt) {
          val = opt[key];
          this[key].apply(this, [].concat(val));
        }
      }
    }

    CypherQuery.prototype.toString = function() {
      var joiner, key, val;
      return ((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = PARTS.length; _i < _len; _i++) {
          key = PARTS[_i];
          if (!((val = this._query[key]) != null)) {
            continue;
          }
          joiner = key === 'where' ? ' AND ' : ', ';
          _results.push(key.toUpperCase() + ' ' + val.join(joiner));
        }
        return _results;
      }).call(this)).join("\n");
    };

    CypherQuery.prototype.execute = function(db, cb) {
      return db.query(this.toString(), this._params, cb);
    };

    CypherQuery.prototype.params = function(params) {
      if (params != null) {
        extend(this._params, params);
        return this;
      } else {
        return this._params;
      }
    };

    part_builder = function(key) {
      return function() {
        var vals, _ref;
        vals = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
        if (!isString(vals[vals.length - 1])) {
          this.params(vals.pop());
        }
        if (this._query[key] == null) {
          this._query[key] = vals;
        } else {
          (_ref = this._query[key]).push.apply(_ref, vals);
        }
        return this;
      };
    };

    for (_i = 0, _len = PARTS.length; _i < _len; _i++) {
      k = PARTS[_i];
      CypherQuery.prototype[k] = part_builder(k);
    }

    CypherQuery.prototype.index = function(index, expr, params) {
      return this.start("n=" + index + "(" + expr + ")", params);
    };

    CypherQuery.prototype.autoindex = function(expr, params) {
      return this.index('node:node_auto_index', expr, params);
    };

    CypherQuery.install = function(target) {
      if (target == null) {
        target = require('neo4j/lib/GrpahDatabase');
      }
      return target.prototype.builder = function(opt) {
        var query;
        query = new CypherQuery(opt);
        query.execute = query.execute.bind(query, this);
        return query;
      };
    };

    return CypherQuery;

  })();

  module.exports = CypherQuery;

}).call(this);
